# Recent development

Tested the ClassDigitizer.h/C for very high rate data recording for single and multiple digitizers, each digitizer has 5 inputs from a pulser. In the condition without trace and Extra2, Max Events per aggregation = 1032 and Max aggregations per BLT = 80. it can run at 100k without problem. 

# Introduction

The FSUDAQ is a GUI, supports One (for now) CAEN x725 and x730 digitizer with either DPP-PHA or DPP-PSD firmware. It uses the CEAN ROOT for the Graphical Interface. 

For other information, please see https://fsunuc.physics.fsu.edu/wiki/index.php/CAEN_digitizer#FSU_DAQ

## Required Library

1. CAENComm 1.4+
2. CAENVMELib 2.5+
3. CAENDigitizer 2.12+
4. CAEN A3818 Driver 1.61+ (for optical link)
5. CERN ROOT 6
6. libcurl4-nss-dev (for the libcurl, used in InfluxDB class)
7. InfluxDB 1.8 (recommanded for trigger rate, optional for database)
7. Elog (optional for auto make elog entry)

## Folder Structure

FSUDAQ \
├── Analysis \
├── DAQ \
├── elogText.txt \
├── (Symbolic link to experiment folder) \
│   ├── data \
│   │   └── *.fsu \
│   ├── settings \
│   ├── FSUDAQ.sh \
│   ├── elogText.txt \
│   ├── elogText2.txt \
│   ├── elogID.txt \
│   └── tempDB.txt \
├── FSUDAQ \
├── FSUDAQDict_rdict.pcm -> DAQ/FSUDAQDict_rdict.pcm \
├── FSUDAQ.sh \
└── README.md 
        
The parent folder FSUDAQ should be placed on the Home directory. The source code for the DAQ is inside the DAQ folder. 

The key codes are :

1. ClassData.h
2. RegisterAddress.h
3. ClassDigitizer.h/cpp

The test.cpp is an example to use the above classes to control and readout digitizer. 

The test_indep.cpp is an example to connect digitizer ONLY with CAEN library.

The rest of the files are for the GUI.

The Analysis folder stores all online analysis codes.

User should also make a symbolic link to the experiment folder.

The FSUDAQ.sh will be created when running the FSUDAQ for the 1st time. It stored the program settings. 

## To Complie

Go to the DAQ folder:

> ~>cd FSUDAQ \
> FSUDAQ>cd DAQ \
> DAQ>make FSUDAQ

It will produce an executable FSUDAQ under the FSUDAQ, and FSUDAQDict_rdict.pcm.

# Usage

The FSUDAQ can be use as 2 ways. With digitizer open, run and take data, Without Digitizer open, open setting file and change it.

## Setup experiment folders

This can be done in 2 ways :

1. Using FSQDAQ. once the FSQDAQ run, it will create the FSUDAQ.sh if not exist. From the menu -> Settings -> Program Settings
2. Edit the FSUDAQ.sh

The data folder can be inside FSUDAQ folder or anywhere.

## Open digitizers

Simply press the "Open Digitizers" button from the FSUDAQ. It wll scan all 4 ports of the fiber optics cards and 3 boards for each port. User can modify the MaxNBoard and MaxNPort in the code and re-compile.

When a digitizer is found, connection will be established. And setting files will be created at the settings folder inside the experiment folder with filename setting_XXX.bin, where XXX is the board serial number. If setting file is found, the setting will be use and program the digitizer. 

### After opened digitizer

Once at least one digitizer is connected. The Board Setting and Channel Setting are avalible. 

1. plot a single trace
2. Continue run the digitizer without taking data. Can plot energy spectrum, count, or traces
3. Take data. This will only take data, fast scanning the data, and dump it to *.fsu file. Files size limit is 2 GB.

## Open *.bin setting file

If no digitizer is open, user can open a setting file. once the setting file is open, the Board setting and Channel setting panels will open. User can change the settings.

User can use the Save button at the board setting to save the setting file into text format. 
